<?php
/**
* @package Joomla
* @subpackage Fabrik
* @copyright Copyright (C) 2005 Rob Clayburn. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

//require the abstract plugin classes
require_once(COM_FABRIK_FRONTEND.DS.'models'.DS.'plugin.php');
require_once(COM_FABRIK_FRONTEND.DS.'models'.DS.'validation_rule.php');

class plgFabrik_validationruleIsgreaterorlessthan extends plgFabrik_Validationrule {

	var $_pluginName = 'isgreaterthanorlessthan';

	/** @param string classname used for formatting error messages generated by plugin */
	var $_className = 'notempty isgreaterthanorlessthan';

	/**
	 * validate the elements data against the rule
	 * @param string data to check
	 * @param object element
	 * @param int plugin sequence ref
	 * @return bol true if validation passes, false if fails
	 */

	function validate($data, &$element, $c)
	{
		//could be a dropdown with multivalues
		if (is_array($data)) {
			$data = implode('', $data);
		}
 		$params =& $this->getParams();
 		$formdata = $element->getForm()->_formData;
 		$cond = $params->get('isgreaterorlessthan-greaterthan');
 		$cond = $cond[$c] == '1' ? '>' : '<';
 		$compare = $params->get('isgreaterorlessthan-comparewith');
 		$compare = str_replace('.', '___', $compare[$c]);
 		$compare = JArrayHelper::getValue($formdata, $compare.'_raw', JArrayHelper::getValue($formdata, $compare, ''));
 		$res = $element->greaterOrLessThan($data, $cond, $compare);
 		return $res;
	}

}
?>