var FbPackage = new Class({
	
	Implements:[Options, Events],
	
	options:{
		liveSite 	:'',
		'tmpl':'components/com_fabrik/views/package/tmpl/default/images/'
	},
	
	initialize: function(options){
		this.setOptions(options);
		this.blocks = $H();
	},

	startLoading: function(senderBlock, msg, inline){
		msg = [msg, 'loading'].pick();
		var inline = inline ? inline : false;
		if (!inline){
			Fabrik.overlay.show();
		}
		if(typeOf(senderBlock) !== 'null'){
			if(typeOf(senderBlock) === 'element'){
				//senderBlock = senderBlock.id;
			}
			// is it in a  window?
			var b = this.blocks.get(senderBlock);
			if(typeOf(b)!== 'null' && b.options.winid !=='' ){
				var win = Fabrik.Windows[b.options.winid];
				win.showSpinner();
			}else{
				var s = this.ensureLoader(senderBlock, inline);
				if(!inline){
					//s.addClass('fbPackageStatusOverlay');
					var l = window.getWidth()/2 - s.getWidth()/2;
					var t = window.getScrollTop() + (window.getHeight()/2 - s.getHeight()/2);
					s.setStyles({left:l, top:t});
					
				}else{
					//s.removeClass('fbPackageStatusOverlay');
				}
				s.getElement('span').set('text', msg);
				s.fade('in');
				//s.show();
			}
		}
	},
	
	ensureLoader:function(senderBlock, inline){
		var inline = inline ? inline : false;
		var existing = inline ? $(senderBlock).getParent().getElement('.fbPackageStatus') : $('fbPackageLoader');
		if(typeOf(existing) === 'null'){
			var i = new Element('img', {'src':this.options.liveSite + this.options.tmpl + 'ajax-loader.gif'});
			var s = new Element('span');
			var d = new Element('div', {'class':'fbPackageStatus'}).adopt(i).adopt(s);
			if(inline){
				d.inject($(senderBlock), 'after');
			}else{
				d.id = 'fbPackageLoader';
				d.inject(document.body);
			}
		}
		var s = inline? $(senderBlock).getParent().getElement('.fbPackageStatus') : $('fbPackageLoader');
		return s;
	},
	
	stopLoading: function(senderBlock, msg, inline){
		var inline = inline ? inline : false;
		msg = [msg, 'complete'].pick();
		if(typeOf(senderBlock) !== 'null'){
		// is it in a window?
			var b = this.blocks.get($(senderBlock).id);
			if(typeOf(b) !== 'null' && b.options.winid !==''){
				var win = Fabrik.Windows[b.options.winid];
				win.hideSpinner();
			}else{
				var s = this.ensureLoader(senderBlock, inline);
				s.getElement('span').set('text', msg);
				(function(){ s.fade('out'); }).delay(100);
				if (!inline) {
					Fabrik.overlay.fade();
				}
			}
		}
	},

	addBlock: function( blockid, block ){
		this.blocks.set(blockid, block);
	},
	
	removeBlock: function( blockid ){
		// attempt to remove block? from memory
		this.blocks.set(blockid, null);
		delete this.blocks.blockid;
	},
	
	// bind a block object to listen to another block objects messages
	
	bindListener:function(fromId, toId){
		this.blocks.each(function(val, key){
			if(toId == key){
				val.addListenTo(fromId);
			}
		});	
	},
	
	// broadcast messages to all blocks
	// @TODO really tables and forms etc should Implement an abstract observable class
	
	sendMessage:function(senderBlock, task, taskStatus, json, msg){
		msg = [msg, 'complete'].pick();
		if(typeOf(json) !== 'object'){
			json = JSON.decode(json);
		}
		//this.stopLoading(senderBlock, msg);
		this.blocks.each(function(block, key){
			block.receiveMessage(senderBlock, task, taskStatus, json);
		});
	},
	
	submitfabrikList: function(listid, task){
		this.blocks.each(function(block, key){
			if(key == 'list_' +  listid){
				this.startLoading($('list_' +  listid));
				if(block.submitfabrikList(task) === false){
					this.stopLoading();
				}
			}
		}.bind(this));
	},
	
	openRedirectInFabrikWindow: function(url, block, inline){
		var loadMethod;
		//if its a site page load via xhr otherwise load as iframe
		loadMethod = 'xhr';
		if(!url.contains(this.options.liveSite) && (url.contains('http://') || url.contains('https://'))){
			loadMethod = 'iframe';
		}
		var opts = {
			'id': 'redirect',
			title: '',
			contentType: 'xhr',
			loadMethod: loadMethod,
			contentURL: url,
			width: 300,
			height: 320,
			'minimizable': false,
			'collapsible': true,
			onContentLoaded: (function(){Fabrik.Windows['redirect'].fitToContent();}).delay(1000)
		};
		var win = new Fabrik.Window(opts);
		if (typeOf(block) !== 'null') {
			this.stopLoading(block, null, inline);
		}
	}
});

var Plugins = new Class({
	
	runPlugins : function(func, event) {
		var args = $A(arguments).filter(function(a, k) {
			return k > 1;
		});
		var ret = true;
		// ie wierdness with multple table plugins in content article?
		if (typeOf(this.options) == 'null'){
			return true;
		}
		this.options.plugins.each( function(plugin) {
			if (typeOf(plugin) !== 'null' && typeOf(plugin[func]) != 'null') {
				if (plugin[func](event, args) == false) {
					ret = false;
				}
			}
		});
		return ret;
	},
	
	addPlugin : function(plugin) {
			this.options.plugins.push(plugin);
	}
});