Tabs = new Class({
	initialize : function(el, tabs, editable) {
		this.editable = editable;
		this.iconGen = new IconGenerator({scale:0.5});
		this.el = $(el);
		this.tabs = $H({});
		this.build(tabs);
	},
	
	build : function(tabs) {
		window.fireEvent('fabrik.history.off', this);
		if(this.editable){
			
			var a = new Element('a', {
				'href' : '#',
				'events' : {
					'click' : this.addWindow.bindWithEvent(this)
				}
			});
			
			art = this.iconGen.create(icon['plus'], {fill:{color:['#40B53E', '#378F36']}});
			art.inject(a);
			
			this.el.adopt(new Element('li', {
				'class' : 'add',
				'events' : {
					'click' : this.addWindow.bindWithEvent(this)
				}
			}).adopt([new Element('span').set('text', 'add'), a]));
		}
		tabs.each(function(t) {
			this.add(t);
		}.bind(this));
		this.setActive(tabs[0]);
		(function() {
			window.fireEvent('fabrik.history.on', this);
		}).delay(500);
	},

	remove : function(e) {
		if (typeOf(e) == 'event') {
			var n = e.target.findUp('li').getElement('span').get('text').trim();
			e.stop();
		} else {
			n = e;
		}
		if(confirm('Delete tab?')){
			if (this.tabs.getLength() <= 1) {
				alert('you can not remove all tabs');
				return;
			}
			var t = this.tabs[n];
			window.fireEvent('fabrik.tab.remove', [ this, t ]);
			this.tabs.erase(n);
			t.destroy();
			var newkey = this.tabs.getKeys()[0];
			this.setActive(this.tabs[newkey]);
		}
	},

	addWindow : function(e) {

		var c = new Element('form');
		c.adopt(new Element('input', {
			'name' : 'label'
		}), new Element('br'), new Element('input', {
			'class' : 'button',
			'type' : 'button',
			'events' : {
				'click' : function(e) {
					var name = e.target.getParent().getElement('input[name=label]').get('value');
					if (name == '') {
						alert('please supply a tab label');
						return false;
					}
					this.add(name);
					Fabrik.Windows[this.windowopts.id].close()
				}.bind(this)
			},
			'value' : 'add'
		}));
		this.windowopts = {
			'id' : 'addTab',
			title : 'Add',
			content : c,
			width : 200,
			height : 150,
			'minimizable' : false,
			'collapsible' : true
		};
		var mywin = new Fabrik.Modal(this.windowopts);
	},

	add : function(t) {
		var li = new Element('li', {
			
			'events' : {
				'click' : function(e) {
					this.setActive(li);
				}.bind(this),
				
				'mouseover':function(e){
					window.fireEvent('fabrik.tab.hover', [ t ]);
				}
			}
		});
		li.adopt(new Element('span').set('text', t + ' '));
		
		var a = new Element('a', {
			'href' : '#',
			'events' : {
				'click' : this.remove.bindWithEvent(this)
			}
		});
		
		if(this.editable){
			art = this.iconGen.create(icon['cross']);
			art.inject(a);
			li.adopt(a);
		}
		li.store('ref', t);
		if(this.editable){
			var add = this.el.getElement('li.add');
			li.inject(add, 'before');
		}else{
			li.inject(this.el, 'inside');
		}
		this.setActive(li);
		this.tabs[t] = li;
		window.fireEvent('fabrik.history.add', [ this, this.remove, t, this.add, t ]);
		window.fireEvent('fabrik.tab.add', [ this, t ]);
	},

	setActive : function(a) {
		var tname = typeOf(a) == 'string' ? a : a.retrieve('ref');
		var active = a;
		window.fireEvent('fabrik.tab.click', tname);
		this.tabs.each(function(t) {
			t.removeClass('active');
			t.addClass('inactive');
			if(t.retrieve('ref') == tname){
				active = t;
			}
		});
		active.addClass('active');
		active.removeClass('inactive');
	},

	reorder : function() {

	}
});